﻿// -------------------------------------------------------
// <autogenerated>
// This file was automatically generated with Reegenerator.
// Any changes made to this file will be removed when this file is regenerated.
// 
// Generator: OneAccomplishment.CodeGen.BusinessRules.RuleMessagesRenderer
// </autogenerated>
// -------------------------------------------------------


namespace OneAccomplishment.Core.BusinessRules.Messages
{
    using System;
    using System.Resources;
    using System.Threading;
    using Net40Utilities.Validation;
    
    /// <summary>
    /// A strongly-typed resource class, for looking up localized strings related
    /// to LoginMessages.
    /// </summary>
    public sealed partial class LoginMessages : AbstractRuleStringResource<LoginMessages>
    {
            private static readonly Lazy<ResourceManager> CommonResourceManager = 
        new Lazy<ResourceManager>(
            () => new ResourceManager(
                "OneAccomplishment.Core.BusinessRules.Messages.CommonMessages",
                typeof(LoginMessages).Assembly),
            LazyThreadSafetyMode.ExecutionAndPublication);

            private static readonly Lazy<ResourceManager> ResourceManager = 
        new Lazy<ResourceManager>(
            () => new ResourceManager(
                "OneAccomplishment.Core.BusinessRules.Messages.LoginMessages",
                typeof(LoginMessages).Assembly),
            LazyThreadSafetyMode.ExecutionAndPublication);


        /// <summary>
        /// Resolves a LoginMessages value from a key.
        /// </summary>
        public static string ResolveKey(string key)
        {
            ArgumentGuard.For(() => key).IsNull().Throw();

            string value = CommonResourceManager.Value.GetString(key, null);
            if (value == null) {
                value = ResourceManager.Value.GetString(key, null);
            }
            return value;
        }
        
        private LoginMessages(string key)
            : base(key, CommonResourceManager.Value, ResourceManager.Value)
        {
        }

        public override bool Equals(object obj)
        {
            return base.Equals(obj);
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }

        public static bool operator ==(LoginMessages a, LoginMessages b)
        {
            return Object.Equals(a, b);
        }

        public static bool operator !=(LoginMessages a, LoginMessages b)
        {
            return !(a == b);
        }

        public static implicit operator string(LoginMessages instance)
        {
            return instance.ToString();
        }

        
    private static readonly Lazy<LoginMessages> MissingRequiredValueInstance = 
        new Lazy<LoginMessages>(
            () => new LoginMessages("MissingRequiredValue"),
            LazyThreadSafetyMode.ExecutionAndPublication);
                
    /// <summary>
    /// Purpose: [COMMON] When a required value is missing.
    /// <para>Gets a localized string similar to '{PropertyName} is required but was not provided.'</para>
    /// </summary>
    public static LoginMessages MissingRequiredValue
    {
        get { return MissingRequiredValueInstance.Value; }
    }
    
    private static readonly Lazy<LoginMessages> CurrentAuthenticationInvalidInstance = 
        new Lazy<LoginMessages>(
            () => new LoginMessages("CurrentAuthenticationInvalid"),
            LazyThreadSafetyMode.ExecutionAndPublication);
                
    /// <summary>
    /// Purpose: When a logout is attempted but the current authentication ticket is invalid.
    /// <para>Gets a localized string similar to 'Current login authentication ticket is invalid.'</para>
    /// </summary>
    public static LoginMessages CurrentAuthenticationInvalid
    {
        get { return CurrentAuthenticationInvalidInstance.Value; }
    }
    
    private static readonly Lazy<LoginMessages> InvalidCredentialsInstance = 
        new Lazy<LoginMessages>(
            () => new LoginMessages("InvalidCredentials"),
            LazyThreadSafetyMode.ExecutionAndPublication);
                
    /// <summary>
    /// Purpose: When domain credential validation fails.
    /// <para>Gets a localized string similar to 'Invalid username or password.'</para>
    /// </summary>
    public static LoginMessages InvalidCredentials
    {
        get { return InvalidCredentialsInstance.Value; }
    }
    
    private static readonly Lazy<LoginMessages> LoginAttemptExceededInstance = 
        new Lazy<LoginMessages>(
            () => new LoginMessages("LoginAttemptExceeded"),
            LazyThreadSafetyMode.ExecutionAndPublication);
                
    /// <summary>
    /// Purpose: When repeated failed login attempts are made.
    /// <para>Gets a localized string similar to 'Login limit reached. Please try again in {0} seconds.'</para>
    /// </summary>
    public static LoginMessages LoginAttemptExceeded
    {
        get { return LoginAttemptExceededInstance.Value; }
    }
    
    private static readonly Lazy<LoginMessages> LoginAttemptNotTrackedInstance = 
        new Lazy<LoginMessages>(
            () => new LoginMessages("LoginAttemptNotTracked"),
            LazyThreadSafetyMode.ExecutionAndPublication);
                
    /// <summary>
    /// Purpose: Fatal scenario: The login attempt was expected to be already tracked in the db but is not.
    /// <para>Gets a localized string similar to 'Login attempt was not tracked.'</para>
    /// </summary>
    public static LoginMessages LoginAttemptNotTracked
    {
        get { return LoginAttemptNotTrackedInstance.Value; }
    }
    
    private static readonly Lazy<LoginMessages> LogoutReasonExpiredInstance = 
        new Lazy<LoginMessages>(
            () => new LoginMessages("LogoutReasonExpired"),
            LazyThreadSafetyMode.ExecutionAndPublication);
                
    /// <summary>
    /// Purpose: Reason for logout was due to the authentication ticket expiring.
    /// <para>Gets a localized string similar to 'Current authentication ticket has expired.'</para>
    /// </summary>
    public static LoginMessages LogoutReasonExpired
    {
        get { return LogoutReasonExpiredInstance.Value; }
    }
    
    private static readonly Lazy<LoginMessages> LogoutReasonManualInstance = 
        new Lazy<LoginMessages>(
            () => new LoginMessages("LogoutReasonManual"),
            LazyThreadSafetyMode.ExecutionAndPublication);
                
    /// <summary>
    /// Purpose: Reason for logout was due to the user's actions.
    /// <para>Gets a localized string similar to 'Logout at the request of the user.'</para>
    /// </summary>
    public static LoginMessages LogoutReasonManual
    {
        get { return LogoutReasonManualInstance.Value; }
    }

    }
}
